## wpa4220v4_GPL.tar.gz

=== Makefile ===
# this is set up to by default to make the top level and test with CppUTest
# You need to separately get and build cpputest from cpputest.org
# You must also define CPPUTEST_HOME.  See the README.txt

all: everything
clean: cleaneverything

codeUnity:
	make -i -f MakefileUnity.mk

cleanCodeCppUTest:
	make -i -f MakefileCppUTest.mk clean
	
cleanCodeUnity:
	make -i -f MakefileUnity.mk clean
	
everything: 
	make -i -C t0
	make -i -C t1
	make -i -C t2
	make -i -C t3
	make -i -C SandBox
	make -i -f MakefileCppUTest.mk 
	make -i -f MakefileUnity.mk

cleaneverything:
	make -i -C t0 clean
	make -i -C t1 clean
	make -i -C t2 clean
	make -i -C t3 clean
	make -i -C SandBox clean
	make -i -f MakefileCppUTest.mk clean
	make -i -f MakefileUnity.mk clean

=== SandBox/Makefile ===
all: 
	make -i -f MakefileCppUTest.mk 
	make -i -f MakefileUnity.mk 

clean:
	make -i -f MakefileCppUTest.mk clean
	make -i -f MakefileUnity.mk clean

=== t0/Makefile ===
#Set this to @ to keep the makefile quiet
SILENCE = @

#---- Outputs ----#
COMPONENT_NAME = t0
TARGET_LIB = \
	lib/lib$(COMPONENT_NAME).a
	
TEST_TARGET = \
	$(COMPONENT_NAME)_tests

#--- Inputs ----#
PROJECT_HOME_DIR = .

CPP_PLATFORM = Gcc

CPPUTEST_WARNINGFLAGS += -Wall 
CPPUTEST_WARNINGFLAGS += -Werror 
CPPUTEST_WARNINGFLAGS += -Wswitch-default 
CPPUTEST_WARNINGFLAGS += -Wswitch-enum  
CPPUTEST_CFLAGS += -std=c89
CPPUTEST_CFLAGS += -Wextra 
CPPUTEST_CFLAGS += -pedantic 
CPPUTEST_CFLAGS += -Wstrict-prototypes

SRC_DIRS = \
	src/util\
	src/HomeAutomation\


TEST_SRC_DIRS = \
	tests \
	tests/HomeAutomation\
	mocks
	
INCLUDE_DIRS =\
  $(CPPUTEST_HOME)/include/\
  include/*\
  mocks
  
ifeq ($(CPPUTEST_HOME),)
$(info CPPUTEST_HOME not set! See README.txt)
else  
include $(CPPUTEST_HOME)/build/MakefileWorker.mk
endif

=== t1/Makefile ===
#Set this to @ to keep the makefile quiet
SILENCE = @

#---- Outputs ----#
COMPONENT_NAME = t1
TARGET_LIB = \
	lib/lib$(COMPONENT_NAME).a
	
TEST_TARGET = \
	$(COMPONENT_NAME)_tests

#--- Inputs ----#
PROJECT_HOME_DIR = .
CPP_PLATFORM = Gcc

CPPUTEST_USE_EXTENSIONS = Y
CPPUTEST_WARNINGFLAGS += -Wall 
CPPUTEST_WARNINGFLAGS += -Werror 
CPPUTEST_WARNINGFLAGS += -Wswitch-default 
CPPUTEST_WARNINGFLAGS += -Wswitch-enum  
CPPUTEST_WARNINGFLAGS += -Wno-self-assign
CPPUTEST_CFLAGS += -std=c89
CPPUTEST_CFLAGS += -Wextra 
CPPUTEST_CFLAGS += -pedantic 
CPPUTEST_CFLAGS += -Wstrict-prototypes

SRC_DIRS = \
	src/*\
	src/MyOS/Acme\

TEST_SRC_DIRS = \
	tests \
	tests/MyOS \
	tests/util \
	tests/devices \
	tests/HomeAutomation\
	tests/IO \
	mocks/IO \
	mocks
	
INCLUDE_DIRS =\
  .\
  $(CPPUTEST_HOME)/include/\
  include/*\
  mocks/IO \
  mocks

  
ifeq ($(CPPUTEST_HOME),)
$(info CPPUTEST_HOME not set! See README.txt)
else  
include $(CPPUTEST_HOME)/build/MakefileWorker.mk
endif

=== t2/Makefile ===
#Set this to @ to keep the makefile quiet
SILENCE = @

#---- Outputs ----#
COMPONENT_NAME = t2
TARGET_LIB = \
	lib/lib$(COMPONENT_NAME).a
	
TEST_TARGET = \
	$(COMPONENT_NAME)_tests

#--- Inputs ----#
PROJECT_HOME_DIR = .
CPP_PLATFORM = Gcc

CPPUTEST_WARNINGFLAGS += -Wall 
CPPUTEST_WARNINGFLAGS += -Werror 
CPPUTEST_WARNINGFLAGS += -Wswitch-default 
CPPUTEST_WARNINGFLAGS += -Wswitch-enum  
CPPUTEST_WARNINGFLAGS += -Wno-self-assign
CPPUTEST_CFLAGS += -std=c89
CPPUTEST_CFLAGS += -Wextra 
CPPUTEST_CFLAGS += -pedantic 
CPPUTEST_CFLAGS += -Wstrict-prototypes

SRC_DIRS = \
	src/*\

TEST_SRC_DIRS = \
	tests \
	tests/util \
	tests/devices \
	tests/HomeAutomation\
	mocks
	
INCLUDE_DIRS =\
  $(CPPUTEST_HOME)/include/\
  include/HomeAutomation\
  include/util\
  mocks\
  include/devices\
  include/MyOS\
  
ifeq ($(CPPUTEST_HOME),)
$(info CPPUTEST_HOME not set! See README.txt)
else  
include $(CPPUTEST_HOME)/build/MakefileWorker.mk
endif

=== t3/Makefile ===
#Set this to @ to keep the makefile quiet
SILENCE = @
#---- Outputs ----#
COMPONENT_NAME = t3
TARGET_LIB = \
	lib/lib$(COMPONENT_NAME).a
	
TEST_TARGET = \
	$(COMPONENT_NAME)_tests

#--- Inputs ----#
PROJECT_HOME_DIR = .
CPP_PLATFORM = Gcc

CPPUTEST_USE_EXTENSIONS = Y
CPPUTEST_WARNINGFLAGS += -Wall 
CPPUTEST_WARNINGFLAGS += -Werror 
CPPUTEST_WARNINGFLAGS += -Wswitch-default 
CPPUTEST_WARNINGFLAGS += -Wswitch-enum  
CPPUTEST_WARNINGFLAGS += -Wno-self-assign
CPPUTEST_CFLAGS += -std=c89
CPPUTEST_CFLAGS += -Wextra 
CPPUTEST_CFLAGS += -pedantic 
CPPUTEST_CFLAGS += -Wstrict-prototypes

SRC_DIRS = \
	src/*\

TEST_SRC_DIRS = \
	tests \
	tests/util \
	tests/devices \
	tests/HomeAutomation\
	mocks
	
INCLUDE_DIRS =\
  $(CPPUTEST_HOME)/include/\
  include/*\
  mocks

ifeq ($(CPPUTEST_HOME),)
$(info CPPUTEST_HOME not set! See README.txt)
else  
include $(CPPUTEST_HOME)/build/MakefileWorker.mk
endif

=== util/json2bin/Makefile ===

CFLAGS := -I./include -I./cJSON -I./encrypt

LDFLAGS := -L./lib -lz -lm

OBJS = ./cJSON/cJSON.o ./encrypt/des_min_enc.o ./encrypt/md5_interface.o\
./encrypt/md5.o ./src/json2bin.o

TARGET = json2bin

all: $(TARGET)

$(TARGET): $(OBJS)
	@echo "LD $@"
	gcc $^ $(LDFLAGS) -o $@

%.o: %.c
	@echo "CC $@"
	gcc -c $(CFLAGS) -o $@ $<

clean:
	@echo clean...
	-rm -f $(OBJS) $(TARGET)

=== util/make_flash_src/Makefile ===

EXE=make_flash

OBJS=make_flash.o md5.o md5_interface.o

ifeq ($(ENABLE_FACTORY_TEST_MODE), 1)
CFLAGS = -DENABLE_FACTORY_TEST_MODE
endif

ARCH_FLAG=-m32

$(EXE):$(OBJS)
	gcc $(CFLAGS) -o $(EXE) $(OBJS) $(ARCH_FLAG)

%.o:%.c
	gcc -c $(CFLAGS) -o $@ $< $(ARCH_FLAG)
	
clean:
	@rm -rf $(EXE) $(OBJS)

=== util/make_header/Makefile ===

EXE=make_header

OBJS=make_header.o md5.o

$(EXE):$(OBJS)
	gcc -o $(EXE) $(OBJS)

%.o:%.c
	gcc -c -o $@ $<
	
clean:
	@rm -rf $(EXE) $(OBJS)

=== util/profile_maker/Makefile ===

CFLAGS := -I./include -I./cJSON -I./encrypt

LDFLAGS := -L./lib -lz -lm

OBJS = ./cJSON/cJSON.o ./encrypt/des_min_enc.o ./encrypt/md5_interface.o\
./encrypt/md5.o ./src/profile_make.o

TARGET = profile_maker

all: $(TARGET)

$(TARGET): $(OBJS)
	@echo "LD $@"
	gcc $^ $(LDFLAGS) -o $@

%.o: %.c
	@echo "CC $@"
	gcc -c $(CFLAGS) -o $@ $<

clean:
	@echo clean...
	-rm -f $(OBJS) $(TARGET)

=== util/squashfs-4.2/Makefile ===
###############################################
#          Compression build options          #
###############################################
#
#
############# Building gzip support ###########
#
# Gzip support is by default enabled, and the compression type default
# (COMP_DEFAULT) is gzip.
#
# If you don't want/need gzip support then comment out the GZIP SUPPORT line
# below, and change COMP_DEFAULT to one of the compression types you have
# selected.
#
# Obviously, you must select at least one of the available gzip, lzma, lzo
# compression types.
#
GZIP_SUPPORT = 1

########### Building XZ support #############
#
# LZMA2 compression.
#
# XZ Utils liblzma (http://tukaani.org/xz/) is supported
#
# To build using XZ Utils liblzma - install the library and uncomment
# the XZ_SUPPORT line below.
#
XZ_SUPPORT = 1


############ Building LZO support ##############
#
# The LZO library (http://www.oberhumer.com/opensource/lzo/) is supported.
#
# To build using the LZO library - install the library and uncomment the
# LZO_SUPPORT line below. If needed, uncomment and set LZO_DIR to the
# installation prefix.
#
#LZO_SUPPORT = 1
#LZO_DIR = /usr/local

########### Building LZMA support #############
#
# LZMA1 compression.
#
# LZMA1 compression is deprecated, and the newer and better XZ (LZMA2)
# compression should be used in preference.
#
# Both XZ Utils liblzma (http://tukaani.org/xz/) and LZMA SDK
# (http://www.7-zip.org/sdk.html) are supported
#
# To build using XZ Utils liblzma - install the library and uncomment
# the LZMA_XZ_SUPPORT line below.
#
# To build using the LZMA SDK (4.65 used in development, other versions may
# work) - download and unpack it, uncomment and set LZMA_DIR to unpacked source,
# and uncomment the LZMA_SUPPORT line below.
#
#LZMA_XZ_SUPPORT = 1
#LZMA_SUPPORT = 1
#LZMA_DIR = ../../../../LZMA/lzma465

######## Specifying default compression ########
#
# The next line specifies which compression algorithm is used by default
# in Mksquashfs.  Obviously the compression algorithm must have been
# selected to be built
#
COMP_DEFAULT = xz
SQUASHFS_DIR := $(shell pwd)
XZ_DIR = $(SQUASHFS_DIR)/../../bcm4708x/src/tools/misc/xz



###############################################
#  Extended attribute (XATTRs) build options  #
###############################################
#
# Building XATTR support for Mksquashfs and Unsquashfs
#
# If your C library or build/target environment doesn't support XATTRs then
# comment out the next line to build Mksquashfs and Unsquashfs without XATTR
# support
XATTR_SUPPORT = 1

# Select whether you wish xattrs to be stored by Mksquashfs and extracted
# by Unsquashfs by default.  If selected users can disable xattr support by
# using the -no-xattrs option
#
# If unselected, Mksquashfs/Unsquashfs won't store and extract xattrs by
# default.  Users can enable xattrs by using the -xattrs option.
XATTR_DEFAULT = 1


###############################################
#        End of BUILD options section         #
###############################################
CC = gcc
RANLIB = ranlib
AR =  ar
AS = as
LD = ld
NM = nm
STRIP = strip

INCLUDEDIR = -I.
INSTALL_DIR = /usr/local/bin

MKSQUASHFS_OBJS = mksquashfs.o read_fs.o sort.o swap.o pseudo.o compressor.o

UNSQUASHFS_OBJS = unsquashfs.o unsquash-1.o unsquash-2.o unsquash-3.o \
	unsquash-4.o swap.o compressor.o

CFLAGS ?= -O2
CFLAGS += $(EXTRA_CFLAGS) $(INCLUDEDIR) -D_FILE_OFFSET_BITS=64 \
	-D_LARGEFILE_SOURCE -D_GNU_SOURCE -DCOMP_DEFAULT=\"$(COMP_DEFAULT)\" \
	-Wall
	
LIBS = -lpthread -lm
ifeq ($(GZIP_SUPPORT),1)
CFLAGS += -DGZIP_SUPPORT
MKSQUASHFS_OBJS += gzip_wrapper.o
UNSQUASHFS_OBJS += gzip_wrapper.o
LIBS += -lz
COMPRESSORS += gzip
endif

ifeq ($(LZMA_SUPPORT),1)
LZMA_OBJS = $(LZMA_DIR)/C/Alloc.o $(LZMA_DIR)/C/LzFind.o \
	$(LZMA_DIR)/C/LzmaDec.o $(LZMA_DIR)/C/LzmaEnc.o $(LZMA_DIR)/C/LzmaLib.o
INCLUDEDIR += -I$(LZMA_DIR)/C
CFLAGS += -DLZMA_SUPPORT
MKSQUASHFS_OBJS += lzma_wrapper.o $(LZMA_OBJS)
UNSQUASHFS_OBJS += lzma_wrapper.o $(LZMA_OBJS)
COMPRESSORS += lzma
endif

ifeq ($(LZMA_XZ_SUPPORT),1)
CFLAGS += -DLZMA_SUPPORT
MKSQUASHFS_OBJS += lzma_xz_wrapper.o
UNSQUASHFS_OBJS += lzma_xz_wrapper.o
LIBS += -llzma
COMPRESSORS += lzma
endif

ifeq ($(XZ_SUPPORT),1)
CFLAGS += -DXZ_SUPPORT
MKSQUASHFS_OBJS += xz_wrapper.o
UNSQUASHFS_OBJS += xz_wrapper.o
CFLAGS += -I$(XZ_DIR)/src/liblzma/api
LIBS += -L$(XZ_DIR)/src/liblzma/.libs -llzma
COMPRESSORS += xz
endif

ifeq ($(LZO_SUPPORT),1)
CFLAGS += -DLZO_SUPPORT
ifdef LZO_DIR
INCLUDEDIR += -I$(LZO_DIR)/include
LZO_LIBDIR = -L$(LZO_DIR)/lib
endif
MKSQUASHFS_OBJS += lzo_wrapper.o
UNSQUASHFS_OBJS += lzo_wrapper.o
LIBS += $(LZO_LIBDIR) -llzo2
COMPRESSORS += lzo
endif

ifeq ($(XATTR_SUPPORT),1)
ifeq ($(XATTR_DEFAULT),1)
CFLAGS += -DXATTR_SUPPORT -DXATTR_DEFAULT
else
CFLAGS += -DXATTR_SUPPORT
endif
MKSQUASHFS_OBJS += xattr.o read_xattrs.o
UNSQUASHFS_OBJS += read_xattrs.o unsquashfs_xattr.o
endif

#
# If LZMA_SUPPORT is specified then LZMA_DIR must be specified too
#
ifeq ($(LZMA_SUPPORT),1)
ifndef LZMA_DIR
$(error "LZMA_SUPPORT requires LZMA_DIR to be also defined")
endif
endif

#
# Both LZMA_XZ_SUPPORT and LZMA_SUPPORT cannot be specified
#
ifeq ($(LZMA_XZ_SUPPORT),1)
ifeq ($(LZMA_SUPPORT),1)
$(error "Both LZMA_XZ_SUPPORT and LZMA_SUPPORT cannot be specified")
endif
endif

#
# At least one compressor must have been selected
#
ifndef COMPRESSORS
$(error "No compressor selected! Select one or more of GZIP, LZMA, XZ or LZO!")
endif

#
# COMP_DEFAULT must be a selected compressor
#
ifeq (, $(findstring $(COMP_DEFAULT), $(COMPRESSORS)))
$(error "COMP_DEFAULT isn't selected to be built!")
endif

.PHONY: all
all: mksquashfs unsquashfs check_lzma

xz_config:
	[ -f $(XZ_DIR)/src/liblzma/.libs/liblzma.a ] || ( \
	cd  $(XZ_DIR) && ./configure --prefix=$(shell pwd) --enable-shared=no \
	)
	cd $(SQUASHFS_DIR)

check_lzma: xz_config
	[ -f $(XZ_DIR)/src/liblzma/.libs/liblzma.a ] || ( $(MAKE) -C $(XZ_DIR) )

mksquashfs: check_lzma $(MKSQUASHFS_OBJS)
	$(CC) $(LDFLAGS) $(EXTRA_LDFLAGS) $(MKSQUASHFS_OBJS) $(LIBS) -o $@

mksquashfs.o: mksquashfs.c squashfs_fs.h mksquashfs.h sort.h squashfs_swap.h \
	xattr.h pseudo.h compressor.h

read_fs.o: read_fs.c squashfs_fs.h read_fs.h squashfs_swap.h compressor.h \
	xattr.h

sort.o: sort.c squashfs_fs.h sort.h mksquashfs.h

swap.o: swap.c

pseudo.o: pseudo.c pseudo.h

compressor.o: compressor.c compressor.h squashfs_fs.h

xattr.o: xattr.c xattr.h squashfs_fs.h squashfs_swap.h mksquashfs.h

read_xattrs.o: read_xattrs.c xattr.h squashfs_fs.h squashfs_swap.h read_fs.h

gzip_wrapper.o: gzip_wrapper.c compressor.h squashfs_fs.h

lzma_wrapper.o: lzma_wrapper.c compressor.h squashfs_fs.h

lzma_xz_wrapper.o: lzma_xz_wrapper.c compressor.h squashfs_fs.h

lzo_wrapper.o: lzo_wrapper.c compressor.h squashfs_fs.h

xz_wrapper.o: xz_wrapper.c compressor.h squashfs_fs.h

unsquashfs: $(UNSQUASHFS_OBJS)
	$(CC) $(LDFLAGS) $(EXTRA_LDFLAGS) $(UNSQUASHFS_OBJS) $(LIBS) -o $@

unsquashfs.o: unsquashfs.h unsquashfs.c squashfs_fs.h squashfs_swap.h \
	squashfs_compat.h xattr.h read_fs.h compressor.h

unsquash-1.o: unsquashfs.h unsquash-1.c squashfs_fs.h squashfs_compat.h

unsquash-2.o: unsquashfs.h unsquash-2.c squashfs_fs.h squashfs_compat.h

unsquash-3.o: unsquashfs.h unsquash-3.c squashfs_fs.h squashfs_compat.h

unsquash-4.o: unsquashfs.h unsquash-4.c squashfs_fs.h squashfs_swap.h \
	read_fs.h

unsquashfs_xattr.o: unsquashfs_xattr.c unsquashfs.h squashfs_fs.h xattr.h


.PHONY: clean
clean:
	-rm -f *.o mksquashfs unsquashfs
	make -C $(XZ_DIR) clean

.PHONY: install
install: mksquashfs unsquashfs
	mkdir -p $(INSTALL_DIR)
	cp mksquashfs $(INSTALL_DIR)
	cp unsquashfs $(INSTALL_DIR)

=== board/model_mtk_mt76xx/build/Makefile ===
############################################################
#GPL code Makefile, by ZQQ, 2017.3.7
############################################################

export BOARD_TYPE?=ralink
export PID?=wpa4530v1
export RELEASE?=eu
export CFG_DOUBLE_BOOT?=1

ifndef PID
$(error "You have to define product id, (PID=wpa4530v1).")
endif

##################################################################################################
# Include the specific configuration files from the config.boardtype file
# here.  This removes the need to set environmental variables through a
# script before building
##################################################################################################
include products_config/$(PID)/config.$(PID)

##################################################################################################
#
#	product makefile.
#
##################################################################################################
include Makefile.$(PID)
#include Makefile.kernelmodules
include Makefile.apps

#################################################################################################
#
#	if BUILD_SUBDIR undefined, then 
#		we want to make a target specified in main-control Makefile	
#	else
#		we want to make a single target in subdir-Makefile,
#		subdir is specified by $(BUILD_SUBDIR)
#	endif
#
##################################################################################################
ifndef BUILD_SUBDIR


##################################################################################################
#
#	common rule	
#
##################################################################################################
%_rebuild: %_clean %_build %_install
	@echo "rebuild <$@> at `date`."

%: %_build %_install
	@echo "built and installed <$@> at `date`."	

	
##################################################################################################
#
#	convenient build target	
#
##################################################################################################
export SDKLIBS_TARGET_COMMON = 
#export TPLIBS_TARGET_COMMON =libcjson libmsgcenter ucm libwrapper liblog libappconf libutil libplcapi libwolfssl
#export TPAPPS_TARGET_COMMON = $(TPAPPS_SELECT)
export TPAPPS_TARGET_COMMON = 
export SDK_TARGET_COMMON = kernel apps
export KERNEL_MODULES_TARGET_COMMON = parentCtrl br_guest_filter
export APPS_TARGET_COMMON = busybox sar bridge wireless_tools 
ifeq ($(TPAPPS_IPV6_ENABLE), 1)
export APPS_TARGET_COMMON := $(APPS_TARGET_COMMON) ipv6_tools
endif

export sdklibs_target = $(SDKLIBS_TARGET_ADDITIONAL) $(filter-out $(SDKLIBS_TARGET_EXCLUDE), $(SDKLIBS_TARGET_COMMON))
export tplibs_target = $(TPLIBS_TARGET_ADDITIONAL) $(filter-out $(TPLIBS_TARGET_EXCLUDE), $(TPLIBS_TARGET_COMMON))
export tpapps_target = $(TPAPPS_TARGET_ADDITIONAL) $(filter-out $(TPAPPS_TARGET_EXCLUDE), $(TPAPPS_TARGET_COMMON))
export sdk_target = $(SDK_TARGET_ADDITIONAL) $(filter-out $(SDK_TARGET_EXCLUDE), $(SDK_TARGET_COMMON))
export kernel_modules_target = $(filter-out $(KERNEL_MODULES_TARGET_EXCLUDE), $(KERNEL_MODULES_TARGET_COMMON)) 
export apps_target = $(APPS_TARGET_ADDITIONAL) $(filter-out $(APPS_TARGET_EXCLUDE), $(APPS_TARGET_COMMON))
export platform_util = fakeroot make_flash json2bin make_header

##################################################################################################
#
#	everything.
#
##################################################################################################
export everyrules = $(addprefix $(PID)_, config prep build install clean)
export everything = $(EVERYTHING_ADDITIONAL) $(filter-out $(EVERYTHING_EXCLUDE), $(sdklibs_target) $(tplibs_target) $(sdk_target) $(tpapps_target))

everything_show:
	#@echo SDKLIBS_TARGET_ADDITIONAL=$(SDKLIBS_TARGET_ADDITIONAL)
	#@echo TPLIBS_TARGET_ADDITIONAL=$(TPLIBS_TARGET_ADDITIONAL)
	#@echo TPAPPS_TARGET_ADDITIONAL=$(TPAPPS_TARGET_ADDITIONAL)
	#@echo SDK_TARGET_ADDITIONAL=$(SDK_TARGET_ADDITIONAL)
	#@echo KERNEL_MODULES_TARGET_COMMON=$(KERNEL_MODULES_TARGET_COMMON)
	#@echo APPS_TARGET_COMMON=$(APPS_TARGET_COMMON)
	#@echo APPS_TARGET_ADDITIONAL=$(APPS_TARGET_ADDITIONAL)
	#@echo TPAPPS_TARGET_COMMON=$(TPAPPS_TARGET_COMMON)
	#@echo EVERYTHING_ADDITIONAL=$(EVERYTHING_ADDITIONAL)
	#@echo everything=$(everything)
	@echo sdklibs_target=$(sdklibs_target) $(tplibs_target) $(sdk_target) $(tpapps_target)
	
	
everything_config:
	@echo will config kernel or apps in future.
#	@make apps_config kernel_config

everything_prep: $(addsuffix _prep, $(platform_util) toolchain fs)
	@make everything_config
ifneq ($(strip $(sdklibs_target)),)
	@make $(sdklibs_target)	
endif

	
# libڱɺضlibĿ¼ŻЧ˴˴lib_targetó	
	
everything_build: $(sdklibs_target) $(tplibs_target) $(addsuffix _build, $(sdk_target) $(tpapps_target))
	@echo make $@ done.

everything_install: $(addsuffix _install, $(everything))
	@echo make $@ done.
	
everything_clean: 
	@make clean finish	

$(everyrules): $(PID)_% : everything_%

# clean all things including util
.PHONY:platform_clean
platform_clean: $(addsuffix _clean, $(everything)) $(addsuffix _clean, $(platform_util))
	@echo make $@ done
	
##################################################################################################
#
#	build host utils, such as:fakeroot make_squashfs make_flash md5_des etc.
#
##################################################################################################
FAKEROOT_PATH=$(CONFIG_FAKEROOT_PATH)
fakeroot_package=fakeroot-1.9.1
.PHONY:fakeroot_prep		
fakeroot_prep:
	@cd $(FAKEROOT_PATH) && \
		rm -rf $(fakeroot_package) && \
		tar -xf $(fakeroot_package).tar.gz && \
		cd $(fakeroot_package) && \
		sed -i 's/        SHELL=/        SHELL=\/bin\/bash #/' ./configure &&\
		./configure --prefix=/usr --disable-nls TOOLPREFIX= STRIP= &&\
		make && sed \
		-e 's,^PREFIX=.*,PREFIX=$(FAKEROOT_PATH)/$(fakeroot_package),g' \
		-e 's,^BINDIR=.*,BINDIR=$(FAKEROOT_PATH)/$(fakeroot_package),g' \
		-e 's,^PATHS=.*,PATHS=$(FAKEROOT_PATH)/$(fakeroot_package)/.libs:/lib:/usr/lib,g' \
		scripts/fakeroot > $(CONFIG_UTIL_PATH)/fakeroot && \
		chmod u+x $(CONFIG_UTIL_PATH)/fakeroot		

fakeroot_clean:
	@echo "make fakeroot_clean" 
	rm -rf $(CONFIG_UTIL_PATH)/fakeroot $(FAKEROOT_PATH)/$(fakeroot_package)

##################################################################################################
#
#	prepare toolchain.
#
##################################################################################################
TOOLCHAIN_PATH=$(CONFIG_TOOLCHAIN_PATH)

.PHONY:toolchain_prep
toolchain_prep:
	$(MAKE) -C $(TOOLCHAIN_PATH) toolchain_prep

##################################################################################################
#
#	prepare rootfs templet
#
##################################################################################################
ROOTFS_PATH=$(CONFIG_ROOTFS_PATH)

.PHONY:fs_prep
fs_prep:
	$(MAKE) -C $(ROOTFS_PATH) fs_prep

##################################################################################################
#
#	prepare make_flash
#
##################################################################################################
MAKEFLASH_PATH=$(CONFIG_MAKEFLASH_PATH)

.PHONY:make_flash_prep
make_flash_prep:
	#$(MAKE) -C $(MAKEFLASH_PATH)
	cp -f $(MAKEFLASH_PATH)/make_flash $(IMAGEPATH) &&\
	cd $(IMAGEPATH) &&\
	chmod 777 make_flash
	
make_flash_clean:
	@echo "make make_flash_clean" 
	rm -f $(MAKEFLASH_PATH)/make_flash

##################################################################################################
#
#	prepare json2bin
#
##################################################################################################
JSON2BIN_PATH=$(CONFIG_JSON2BIN_PATH)

.PHONY:json2bin_prep
json2bin_prep:
	#$(MAKE) -C $(JSON2BIN_PATH)
	cp -f $(JSON2BIN_PATH)/json2bin $(IMAGEPATH) &&\
	cd $(IMAGEPATH) &&\
	chmod 777 json2bin	

##################################################################################################
#
#	prepare make_header
#
##################################################################################################
MAKEHEADER_PATH=$(CONFIG_MAKEHEADER_PATH)

.PHONY:make_header_prep
make_header_prep:
	#$(MAKE) -C $(MAKEHEADER_PATH)
	cp -f $(MAKEHEADER_PATH)/make_header.sh $(IMAGEPATH) &&\
	cd $(IMAGEPATH) &&\
	chmod 777 make_header.sh
	cp -f $(MAKEHEADER_PATH)/make_header $(IMAGEPATH) &&\
	cd $(IMAGEPATH) &&\
	chmod 777 make_header
#################################################################################################
#
#	uboot build( cfe )
#
##################################################################################################
UBOOT_PATH=$(CONFIG_UBOOT_PATH)

.PHONY:uboot_build uboot_install uboot_clean

uboot_build:
	$(MAKE) -C $(UBOOT_PATH) uboot

uboot_install:
	@echo uboot: installing u-boot.bin
	@cp $(UBOOT_PATH)/u-boot.bin $(BOARD_TOPDIR)/images/$(PID)/u-boot.bin

uboot_clean:
	@echo Making uboot clean
	$(MAKE) -C $(UBOOT_PATH) clean
	cd $(UBOOT_PATH) && rm -f $(UBOOT_PATH)/u-boot.bin

#################################################################################################
#
#	factory uboot build( cfe )
#
##################################################################################################

.PHONY:factory_uboot_build factory_uboot_install factory_uboot_clean

factory_uboot_build: factory_uboot_clean
	$(MAKE) -C $(UBOOT_PATH) uboot CFG_DOUBLE_BOOT_FACTORY=1

factory_uboot_install:
	@echo uboot: installing factory-uboot.bin
	@cp $(UBOOT_PATH)/factory-uboot.bin $(BOARD_TOPDIR)/images/$(PID)/factory-uboot.bin

factory_uboot_clean:
	@echo Making factory-uboot clean
	$(MAKE) -C $(UBOOT_PATH) clean
	cd $(UBOOT_PATH) && rm -f $(UBOOT_PATH)/factory-uboot.bin

#################################################################################################
#
#	fs uboot build( cfe )
#
##################################################################################################

.PHONY:fs_uboot_build fs_uboot_install fs_uboot_clean

fs_uboot_build: fs_uboot_clean
	$(MAKE) -C $(UBOOT_PATH) uboot CFG_DOUBLE_BOOT_SECOND=1

fs_uboot_install:
	@echo uboot: installing fs-uboot.bin
	@cp $(UBOOT_PATH)/fs-uboot.bin $(BOARD_TOPDIR)/images/$(PID)/fs-uboot.bin

fs_uboot_clean:
	@echo Making fs-uboot clean
	$(MAKE) -C $(UBOOT_PATH) clean
	cd $(UBOOT_PATH) && rm -f $(UBOOT_PATH)/fs-uboot.bin

##################################################################################################
#
#	kernel build.
#
##################################################################################################
KERNEL_PATH=$(CONFIG_KERNEL_PATH)

.PHONY:kernel_build kernel_install kernel_clean

kernel_config:
	@echo kernel: will config kernel.

kernel_build: kernel_config
	$(MAKE) -C $(KERNEL_PATH) kernel_build

kernel_install:
	@echo kernel: installing kernel
	cp $(KERNEL_PATH)/vmlinux $(BOARD_TOPDIR)/images/$(PID)/vmlinux
	cp $(KERNEL_PATH)/vmlinux.bin $(BOARD_TOPDIR)/images/$(PID)/vmlinux.bin
	cp $(KERNEL_PATH)/vmlinux.bin.gz $(BOARD_TOPDIR)/images/$(PID)/vmlinux.bin.gz

kernel_clean:
	rm -f $(KERNEL_PATH)/vmlinux
	rm -f $(KERNEL_PATH)/vmlinux.bin
	rm -f $(KERNEL_PATH)/vmlinux.bin.gz
	$(MAKE) -C $(KERNEL_PATH) kernel_clean

###################################################################################
#   makemod(subdirs, targets)
#  subdirsĿ¼µںģ飬
#  installʱtargetsĿ$(INSTALL_ROOT)/lib/modules/$(KERNELVER)/kernel/
###################################################################################
kernel_modules_%: $(addsuffix _%, $(kernel_modules_target))
	@echo make $@ at `date`
	
##################################################################################################
#
#	applications.
#
##################################################################################################
apps_%: $(addsuffix _%, $(apps_target))
	@echo make $@ at `date`	
	
sdk_apps_%: $(addsuffix _%, rt2880_app)
	@echo make $@ at `date`		

tplibs_%: $(addsuffix _%, $(tplibs_target))
	@echo make $@ at `date`

=== debian/changelog ===
fakeroot (1.9.1) unstable; urgency=low

  * Apply patch from Andrew Benham to handle padding under Sun Studio
    on Solaris.
  * Apply patch from Andrew Benham to make compare-tar test more
    portable.
  * Add Fakeroot::Stat from THUS plc to a contrib/ directory
    in the source tarball.  closes: #459728.

 -- Clint Adams <schizo@debian.org>  Mon, 21 Jan 2008 17:16:22 -0500

fakeroot (1.9) unstable; urgency=low

  * Bump to Standards-Version 3.7.3. 
  * Apply patch from Thomas Bächler to work around fakeroot's
    inability to handle acls by pretending that the underlying
    filesystem does not support acls.  closes: #361306.
  * Add build-dependency on libacl1-dev.

 -- Clint Adams <schizo@debian.org>  Sat, 05 Jan 2008 13:53:26 -0500

fakeroot (1.8.10) unstable; urgency=medium

  * Call biarch target in a parallel-build-friendly way. 

 -- Clint Adams <schizo@debian.org>  Sun, 02 Dec 2007 17:33:42 -0500

fakeroot (1.8.9) unstable; urgency=low

  * Apply patch from Andrew Benham to handle platforms without
    __builtin_expect support in the compiler.  closes: #453303.
  * Add Vcs-Arch and Vcs-Browser fields to control file.

 -- Clint Adams <schizo@debian.org>  Sun, 02 Dec 2007 16:13:44 -0500

fakeroot (1.8.8) unstable; urgency=low

  * Fix configure test to handle platforms where the return value
    of readlink is ssize_t and this is not the same size as int.

 -- Clint Adams <schizo@debian.org>  Wed, 21 Nov 2007 16:57:33 -0500

fakeroot (1.8.7) unstable; urgency=low

  * Apply patch from Andrew Benham to handle platforms without
    setenv() and unsetenv().  closes: #452224.
  * Use setenv compatibility code from GNU libc CVS HEAD.

 -- Clint Adams <schizo@debian.org>  Wed, 21 Nov 2007 09:39:29 -0500

fakeroot (1.8.6) unstable; urgency=low

  * Apply patch from Andrew Benham to handle 64-bit builds on Solaris.
    closes: #452095.
  * Apply patch from Andrew Benham to add mode support to
    fake_get_owner().  closes: #452225.

 -- Clint Adams <schizo@debian.org>  Tue, 20 Nov 2007 21:56:58 -0500

fakeroot (1.8.5) unstable; urgency=low

  * Add gcc-multilib to build dependencies for kfreebsd-amd64.
    closes: #451504.

 -- Clint Adams <schizo@debian.org>  Fri, 16 Nov 2007 09:24:00 -0500

fakeroot (1.8.4) unstable; urgency=low

  * Fix fake_get_owner() to build with STUPID_ALPHA_HACK. 

 -- Clint Adams <schizo@debian.org>  Fri, 02 Nov 2007 21:41:27 -0400

fakeroot (1.8.3) unstable; urgency=low

  * Apply patch from Andrew Benham to handle building with non-GNU
    tr.  closes: #448631.
  * Apply patch from Andrew Benham to handle building with a C
    compiler other than GCC.  closes: #448631.
  * Apply patch from Andrew Benham to add fake_get_owner() function
    as part of undocumented API.

 -- Clint Adams <schizo@debian.org>  Tue, 30 Oct 2007 12:39:09 -0400

fakeroot (1.8.2) unstable; urgency=low

  * Apply fix from Dominique Quatravaux to avoid race condition with
    save files.  closes: #446351, #381016.

 -- Clint Adams <schizo@debian.org>  Fri, 12 Oct 2007 10:09:48 -0400

fakeroot (1.8.1) unstable; urgency=low

  * Apply patch from Jan Kluka to avoid possibility of faked dropping
    into an endless loop with nonexistent save file.

 -- Clint Adams <schizo@debian.org>  Sun, 07 Oct 2007 20:24:04 -0400

fakeroot (1.8) unstable; urgency=medium

  * Apply patch from Jan Kluka to fix up database saving.
    closes: #443307.

 -- Clint Adams <schizo@debian.org>  Thu, 20 Sep 2007 13:46:25 -0400

fakeroot (1.7.1) unstable; urgency=low

  * Apply patch from Alexey Shabalovskiy to cope with save-files
    that are named pipes.

 -- Clint Adams <schizo@debian.org>  Thu, 10 May 2007 10:54:23 -0400

fakeroot (1.7.0.2) unstable; urgency=low

  * Drop shlibs file, as it is no longer necessary.

 -- Clint Adams <schizo@debian.org>  Sun, 06 May 2007 20:40:09 -0400

fakeroot (1.7.0.1) unstable; urgency=low

  * Build-depend on gcc-multilib on biarch architectures.
  * Consolidate biarch build-dependencies.

 -- Clint Adams <schizo@debian.org>  Sun, 06 May 2007 19:30:34 -0400

fakeroot (1.7) unstable; urgency=low

  * Forward-port and apply patch from Henrik Eriksson to add support
    for fstatat(), fstatat64(), mknodat(), fchmodat(), mkdirat(),
    openat(), renameat(), unlinkat().  closes: #402688.

 -- Clint Adams <schizo@debian.org>  Fri, 13 Apr 2007 12:51:16 -0400

fakeroot (1.6.5) unstable; urgency=low

  * Remove setuid fake libraries and README.fake explanation. 

 -- Clint Adams <schizo@debian.org>  Mon, 19 Mar 2007 11:20:58 -0400

fakeroot (1.6.4) unstable; urgency=low

  * Apply patch from Martijn Dekker to add Dutch man page translations.
  * gzip Dutch man pages.

 -- Clint Adams <schizo@debian.org>  Sun,  4 Mar 2007 10:56:55 -0500

fakeroot (1.6.3) unstable; urgency=low

  * Attempt to prevent nested fakeroot invocations.

 -- Clint Adams <schizo@debian.org>  Tue, 27 Feb 2007 22:30:23 -0500

fakeroot (1.6.2) unstable; urgency=low

  * Apply patch from Heikki Lindholm to fix MacOS X support even more.
  * Add MacOS X portability note (two-level namespaces break) to
    README.

 -- Clint Adams <schizo@debian.org>  Tue, 27 Feb 2007 09:34:43 -0500

fakeroot (1.6.1) unstable; urgency=low

  * Apply patch from Heikki Lindholm to fix MacOS X support.

 -- Clint Adams <schizo@debian.org>  Sun, 25 Feb 2007 11:35:30 -0500

fakeroot (1.6) unstable; urgency=medium

  * Apply patch from Christian Ehrhardt to use stat64 internally
    where available.  closes: #407553.

 -- Clint Adams <schizo@debian.org>  Fri, 23 Feb 2007 11:53:21 -0500

fakeroot (1.5.13) unstable; urgency=low

  * Add README to describe cases wherein one should use TCP rather
    than SYSV IPC:
    - multithreaded app creates IPC problems.  closes: #229050.
    - slow with a realtime-preempt kernel.  closes: #319474.

 -- Clint Adams <schizo@debian.org>  Fri, 23 Feb 2007 10:51:39 -0500

fakeroot (1.5.12) unstable; urgency=low

  * Fix build-dep for kfreebsd-amd64. 



=== debian/control ===
Source: fakeroot
Section: utils
Priority: optional
Build-Depends: sharutils, gcc-multilib [amd64 i386 kfreebsd-amd64 powerpc s390 sparc], lib64c-dev [i386 powerpc s390 sparc], lib32c-dev [amd64 kfreebsd-amd64 ppc64], libacl1-dev
Maintainer: Clint Adams <schizo@debian.org>
Standards-Version: 3.7.3
Vcs-Arch: http://arch.debian.org/arch/fakeroot/fakeroot/
Vcs-Browser: http://arch.debian.org/cgi-bin/archzoom.cgi/fakeroot@packages.debian.org--fakeroot?expand

Package: fakeroot
Architecture: any
Depends: ${shlibs:Depends}
Description: Gives a fake root environment
 This package is intended to enable something like:
   dpkg-buildpackage -rfakeroot
 i.e. to remove the need to become root for a package build.
 This is done by setting LD_PRELOAD to libfakeroot.so,
 which provides wrappers around getuid, chown, chmod, mknod, 
 stat, and so on, thereby creating a fake root environment.
 .
 fakeroot requires SYSV IPC or TCP to operate.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_GNU_TYPE = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CONFARGS = --host=$(DEB_HOST_GNU_TYPE)
endif

CFLAGS = -W -Wall -g
INSTALL = install
INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
INSTALL_SCRIPT  = $(INSTALL) -p    -o root -g root  -m  755
INSTALL_DIR     = $(INSTALL) -p -d -o root -g root  -m  755

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif

ifeq (x86_64-linux-gnu,$(DEB_HOST_GNU_TYPE))
BIARCH_LIB_DIR=emul/ia32-linux/usr/lib
else
ifneq (,$(findstring $(DEB_HOST_GNU_TYPE), ppc64-linux-gnu x86_64-kfreebsd-gnu))
BIARCH_LIB_DIR=usr/lib32
else
BIARCH_LIB_DIR=usr/lib64
endif
endif

fakeroot_version := $(shell dpkg-parsechangelog | sed -n '/^Version: \(.*\)$$/ {s//\1/;p}')

build: build-stamp
build-stamp:
	$(checkdir)

	mkdir obj-sysv obj-tcp
	cd obj-sysv && CFLAGS="$(CFLAGS)" ../configure --prefix=/usr --mandir=/usr/share/man --libdir=/usr/lib/libfakeroot --program-suffix=-sysv $(CONFARGS)

	cd obj-tcp && CFLAGS="$(CFLAGS)" ../configure --prefix=/usr --mandir=/usr/share/man --libdir=/usr/lib/libfakeroot --with-ipc=tcp --program-suffix=-tcp $(CONFARGS)

	cd obj-sysv && $(MAKE)
	cd obj-tcp && $(MAKE)

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-sysv && $(MAKE) check
	cd obj-tcp && $(MAKE) check
endif
endif

	touch build-stamp

clean: checkroot
	$(checkdir)
	rm -rf obj-sysv obj64-sysv obj-tcp obj64-tcp
	rm -f build-stamp build-biarch-stamp
#	 Add here commands to clean up after the build process.
	-cd obj-sysv && $(MAKE) distclean
	-cd obj-tcp && $(MAKE) distclean
ifneq (,$(findstring $(DEB_HOST_GNU_TYPE), sparc-linux-gnu s390-linux-gnu x86_64-linux-gnu i486-linux-gnu powerpc-linux-gnu ppc64-linux-gnu x86_64-kfreebsd-gnu))
	-cd obj64-sysv && $(MAKE) distclean
	-cd obj64-tcp && $(MAKE) distclean
endif
	rm -rf .deps
	rm -f debian/substvars debian/files
	rm -rf debian/tmp obj obj64 autom4te.cache
	find . -type f -a \( -name \#\*\# -o -name .\*\~ -o -name \*\~ -o -name DEADJOE -o -name \*.orig -o -name \*.rej -o -name \*.bak -o -name .\*.orig -o -name .\*.rej -o -name .SUMS -o -name TAGS -o -name core -o \( -path \*/.deps/\* -a -name \*.P \) \) -exec rm -f {} \;

# Build architecture-independent files here.
binary-indep: build
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build checkroot
	$(checkdir)

	cd obj-tcp && $(MAKE) DESTDIR="$(CURDIR)/debian/tmp" install
	mv debian/tmp/usr/lib/libfakeroot/libfakeroot-0.so debian/tmp/usr/lib/libfakeroot/libfakeroot-tcp.so
	rm debian/tmp/usr/lib/libfakeroot/libfakeroot.so

	cd obj-sysv && $(MAKE) DESTDIR="$(CURDIR)/debian/tmp" install

	mv debian/tmp/usr/lib/libfakeroot/libfakeroot-0.so debian/tmp/usr/lib/libfakeroot/libfakeroot-sysv.so
	rm debian/tmp/usr/lib/libfakeroot/libfakeroot.so

	$(INSTALL_DIR) debian/tmp/DEBIAN debian/tmp/usr/bin/
#	$(INSTALL_SCRIPT) scripts/fakeroot debian/tmp/usr/bin/
	$(INSTALL_DIR) debian/tmp/usr/share/doc/fakeroot \
		           debian/tmp/usr/lib/libfakeroot
	$(INSTALL_FILE) README doc/README.saving DEBUG debian/tmp/usr/share/doc/fakeroot/
	( echo "fakeroot was written originally by"; \
	  echo "joost witteveen"                   ; \
	  echo "------------------------------------------------"; \
	  cat COPYING) > debian/tmp/usr/share/doc/fakeroot/copyright
#	cd obj-sysv && ./libtool --finish $(CURDIR)/debian/tmp/usr/lib/fakeroot
	rm -f debian/tmp/usr/lib/libfakeroot/libfakeroot.*a*
	rm -f debian/tmp/usr/bin/simple
ifneq (,$(findstring $(DEB_HOST_GNU_TYPE), sparc-linux-gnu s390-linux-gnu x86_64-linux-gnu i486-linux-gnu powerpc-linux-gnu ppc64-linux-gnui x86_64-kfreebsd-gnu))
	$(MAKE) -f debian/rules binary-biarch
endif
	$(INSTALL_FILE) debian/copyright debian/tmp/usr/share/doc/fakeroot/copyright
	$(INSTALL_FILE) debian/changelog debian/tmp/usr/share/doc/fakeroot/changelog
	gzip -9f debian/tmp/usr/share/man/man1/faked-sysv.1 \
		 debian/tmp/usr/share/man/man1/fakeroot-sysv.1 \
		 debian/tmp/usr/share/man/man1/faked-tcp.1 \
		 debian/tmp/usr/share/man/man1/fakeroot-tcp.1 \
		 debian/tmp/usr/share/man/es/man1/faked-sysv.1 \
		 debian/tmp/usr/share/man/es/man1/fakeroot-sysv.1 \
		 debian/tmp/usr/share/man/es/man1/faked-tcp.1 \
		 debian/tmp/usr/share/man/es/man1/fakeroot-tcp.1 \
		 debian/tmp/usr/share/man/fr/man1/faked-sysv.1 \
		 debian/tmp/usr/share/man/fr/man1/fakeroot-sysv.1 \
		 debian/tmp/usr/share/man/fr/man1/faked-tcp.1 \
		 debian/tmp/usr/share/man/fr/man1/fakeroot-tcp.1 \
		 debian/tmp/usr/share/man/nl/man1/faked-sysv.1 \
		 debian/tmp/usr/share/man/nl/man1/fakeroot-sysv.1 \
		 debian/tmp/usr/share/man/nl/man1/faked-tcp.1 \
		 debian/tmp/usr/share/man/nl/man1/fakeroot-tcp.1 \
		 debian/tmp/usr/share/man/sv/man1/faked-sysv.1 \
		 debian/tmp/usr/share/man/sv/man1/fakeroot-sysv.1 \
		 debian/tmp/usr/share/man/sv/man1/faked-tcp.1 \
		 debian/tmp/usr/share/man/sv/man1/fakeroot-tcp.1 \
		 debian/tmp/usr/share/doc/fakeroot/changelog
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	strip --remove-section=.comment --remove-section=.note --strip-unneeded debian/tmp/usr/lib/libfakeroot/libfakeroot-sysv.so
	strip --remove-section=.comment --remove-section=.note --strip-unneeded debian/tmp/usr/lib/libfakeroot/libfakeroot-tcp.so
	strip --remove-section=.comment --remove-section=.note debian/tmp/usr/bin/faked-sysv
	strip --remove-section=.comment --remove-section=.note debian/tmp/usr/bin/faked-tcp
#	strip --strip-debug debian/tmp/usr/lib/libfakeroot.a
endif
	$(INSTALL_SCRIPT) debian/fakeroot.postrm debian/tmp/DEBIAN/postrm
	$(INSTALL_SCRIPT) debian/fakeroot.prerm debian/tmp/DEBIAN/prerm
ifneq ($(DEB_HOST_GNU_SYSTEM),gnu)
	sed 's/@FAKEROOT_SYSV_ALTPRIO@/50/;s/@FAKEROOT_TCP_ALTPRIO@/30/;' \
		debian/fakeroot.postinst.in > debian/fakeroot.postinst
else
	sed 's/@FAKEROOT_SYSV_ALTPRIO@/30/;s/@FAKEROOT_TCP_ALTPRIO@/50/;' \
		debian/fakeroot.postinst.in > debian/fakeroot.postinst
endif
	$(INSTALL_SCRIPT) debian/fakeroot.postinst debian/tmp/DEBIAN/postinst
	rm -f debian/fakeroot.postinst
	# We can just use the deps for faked.
	dpkg-shlibdeps -Tdebian/substvars \
		debian/tmp/usr/bin/faked-sysv \
		debian/tmp/usr/bin/faked-tcp
	dpkg-gencontrol -ldebian/changelog -isp -Tdebian/substvars -Pdebian/tmp
	chmod 644 debian/tmp/DEBIAN/control
	chown root:root debian/tmp/DEBIAN/control
	cd debian/tmp && find * -type f ! -regex '^DEBIAN/.*' -print0 | xargs -r0 md5sum > DEBIAN/md5sums
	dpkg-deb --build debian/tmp ..

binary-biarch:
	$(checkdir)
	mkdir obj64-sysv obj64-tcp

ifneq (,$(findstring $(DEB_HOST_GNU_TYPE),sparc-linux-gnu))
	cd obj64-sysv && CC="gcc -m64" ../configure --prefix=/usr --mandir=/usr/share/man --build=sparc-linux --host=sparc64-linux-gnu --program-suffix=-sysv $(CONFARGS)
	cd obj64-tcp && CC="gcc -m64" ../configure --prefix=/usr --mandir=/usr/share/man --build=sparc-linux --host=sparc64-linux-gnu --with-ipc=tcp --program-suffix=-tcp $(CONFARGS)
endif
ifneq (,$(findstring $(DEB_HOST_GNU_TYPE),s390-linux-gnu))
	cd obj64-sysv && CC="gcc -m64" ../configure --prefix=/usr --mandir=/usr/share/man --build=s390-linux --host=s390x-linux-gnu --program-suffix=-sysv $(CONFARGS)
	cd obj64-tcp && CC="gcc -m64" ../configure --prefix=/usr --mandir=/usr/share/man --build=s390-linux --host=s390x-linux-gnu --with-ipc=tcp --program-suffix=-tcp $(CONFARGS)
endif
ifneq (,$(findstring $(DEB_HOST_GNU_TYPE),x86_64-linux-gnu))
	cd obj64-sysv && CC="gcc -m32" ../configure --prefix=/usr --mandir=/usr/share/man --build=x86_64-linux --host=i486-linux-gnu --program-suffix=-sysv $(CONFARGS)
	cd obj64-tcp && CC="gcc -m32" ../configure --prefix=/usr --mandir=/usr/share/man --build=x86_64-linux --host=i486-linux-gnu --with-ipc=tcp --program-suffix=-tcp $(CONFARGS)
endif
